package com.tti.hd3web.register.faces; 

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.faces.application.FacesMessage;
import javax.faces.component.html.HtmlPanelGrid;
import javax.faces.context.FacesContext;
import javax.faces.model.SelectItem;

import org.richfaces.component.html.HtmlDataTable;

import com.tti.hd3web.register.facade.CountryFacade;
import com.tti.hd3web.register.model.Country;
import com.tti.richfaces.InfraConstants;
import com.tti.richfaces.UserInfo;
import com.tti.richfaces.Util;
import com.tti.richfaces.i18n.I18nMessagesUtil;

public class CountryManagedBean implements Serializable {

	private Country country;
	private String txLongName1Filter = "";
	private List<SelectItem> optionList = new ArrayList<SelectItem>();
	
	private HtmlDataTable dataTable;

	public HtmlDataTable getDataTable() {
		return dataTable;
	}
	public void setDataTable(HtmlDataTable dataTable) {
		this.dataTable = dataTable;
	}
	
	public String getTxLongName1Filter() {
		return txLongName1Filter;
	}
	public void setTxLongName1Filter(String txLongName1Filter) {
		this.txLongName1Filter = txLongName1Filter;
	}
	public Country getCountry() {
		return country;
	}
	public void setCountry(Country country) {
		this.country = country;
	}
	private CountryFacade countryFacade;
	
		
	public CountryFacade getCountryFacade() {
		return countryFacade;
	}
	public void setCountryFacade(CountryFacade countryFacade) {
		this.countryFacade = countryFacade;
	}
	public void create(){
	try{	
		this.country.setDtCreation(new Date());
		Map<String, Object> sessionMap = FacesContext.getCurrentInstance().getExternalContext().getSessionMap();
		UserInfo userInfo = (UserInfo) sessionMap.get(InfraConstants.USER_INFO_SESSION_KEY);
		this.country.getSecContext().setIdSecContext(userInfo.getContext().getIdSecContext());
		//this.country.setIdSecContext(userInfo.getContext().getIdSecContext());
		countryFacade.insertCountry(this.country);
		this.country = new Country();
		message();
		}catch (Exception e) {
			e.printStackTrace();
		}
	}
	public List<Country> getList() {
		return countryFacade.listCountry("%" + this.txLongName1Filter.toUpperCase() + "%");
	}
	public void novo() {
		this.country = new Country();
	}

	public void save() {
		if (this.country.getIdCountry() == null) {
			create();
		} else {
			update();
		}
		
		//limpa os campos
		//this.country = new Country();
		
		
	}
	
	//inicio limpeza form
	private HtmlPanelGrid editPanelGrid;
	public HtmlPanelGrid getEditPanelGrid() {
		return editPanelGrid;
	}
	public void setEditPanelGrid(HtmlPanelGrid editPanelGrid) {
		this.editPanelGrid = editPanelGrid;
	}
	private HtmlPanelGrid newPanelGrid;
	public HtmlPanelGrid getNewPanelGrid() {
		return newPanelGrid;
	}
	public void setNewPanelGrid(HtmlPanelGrid newPanelGrid) {
		this.newPanelGrid = newPanelGrid;
	}

	public void clear() {  
		this.country = new Country();
		Util.clearChildren(this.newPanelGrid);
		Util.clearChildren(this.editPanelGrid);
	}
	//fim limpeza form
	
	public void edit() {
		clear();
		Country c = (Country) this.dataTable.getRowData();
		System.out.println(c.getIdCountry() + " - " + c.getTxLongName1());
		setCountry(c);
	}
	public void update() {
		country.setDtModify(new Date());
		countryFacade.updateCountry(this.country);
	}
	
	public void delete() {
		try {
			countryFacade.deleteCountry(this.country);
		} catch (Exception e) {
			FacesContext context = FacesContext.getCurrentInstance();
			context.addMessage("teste", new FacesMessage(FacesMessage.SEVERITY_ERROR, "No foi possvel excluir!\nO registro pode estar sendo usado em outros cadastros.", "iiiiiiiiiii"));
			Iterator<FacesMessage> it = context.getMessages();

		}
	}
		
	public List<Country> getListAll() {
		return countryFacade.listCountry("%%");
	}

	public List<SelectItem> getCountryListOptions() {
		List<SelectItem> optionList = new ArrayList<SelectItem>();
		
		List<Country> list = getListAll();
		for (Iterator<Country> iterator = list.iterator(); iterator.hasNext();) {
			Country country = (Country) iterator.next();
			optionList.add(new SelectItem(country.getIdCountry(), country.getTxLongName1()));
		}
		
		return optionList;
	}
	
	public void message(){
		FacesContext context = FacesContext.getCurrentInstance();
		String updateMsg = I18nMessagesUtil.getSimpleMessageString("screen.msgs_popup.message.txMsgUpdate", context);
		String createMsg = I18nMessagesUtil.getSimpleMessageString("screen.msgs_popup.message.txMsgInsert", context);
		if(this.country.getIdCountry() != null){							
			FacesMessage message = new FacesMessage(FacesMessage.SEVERITY_INFO,updateMsg,"");
			context.addMessage("editPanel",message);
		}else{
			FacesMessage message = new FacesMessage(FacesMessage.SEVERITY_INFO,createMsg,"");
			context.addMessage("editPanel",message);
		}
		
	}
	
	public List<Country> listAll() {
		return countryFacade.listCountry("%%");
	}
	
	public List<SelectItem> getOptionList() {
		optionList = new ArrayList<SelectItem>();

		List<Country> liststate = listAll();
		
		for (Iterator<Country> iterator = liststate.iterator(); iterator.hasNext();) {
			Country country= (Country) iterator.next();
			optionList.add(new SelectItem(country.getIdCountry(),country.getTxLongName1()));
		}
		
		return optionList;
	}
	
	public List<SelectItem> getOptionsListToCountry() {
		
		optionList = new ArrayList<SelectItem>();

		List<Country> liststate = listAll();
		
		for (Iterator<Country> iterator = liststate.iterator(); iterator.hasNext();) {
			Country country= (Country) iterator.next();
			if(country.getRecordStatus().getIdRecordStatus()==1){
				optionList.add(new SelectItem(country.getIdCountry(),country.getTxLongName1()));
			}
		}
		
		return optionList;
	}

}
